diff --git a/drivers/gpu/drm/bridge/Kconfig b/drivers/gpu/drm/bridge/Kconfig
index 6b4664d91faa8..8b69977787883 100644
--- a/drivers/gpu/drm/bridge/Kconfig
+++ b/drivers/gpu/drm/bridge/Kconfig
@@ -90,6 +90,16 @@ config DRM_FSL_LDB
 	help
 	  Support for i.MX8MP DPI-to-LVDS on-SoC encoder.
 
+config DRM_IMX9_PARALLEL_DISPLAY_FORMAT
+	tristate "Support for i.MX93 parallel display format"
+	depends on OF && MFD_SYSCON
+	depends on ARCH_MXC || COMPILE_TEST
+	select DRM_KMS_HELPER
+	select DRM_PANEL_BRIDGE
+	help
+	  Support for internal parallel display format configuration
+	  found on i.MX91 and i.MX93 processors.
+
 config DRM_ITE_IT6263
 	tristate "ITE IT6263 LVDS/HDMI bridge"
 	depends on OF
diff --git a/drivers/gpu/drm/bridge/Makefile b/drivers/gpu/drm/bridge/Makefile
index 97304b429a530..ee3406fed880f 100644
--- a/drivers/gpu/drm/bridge/Makefile
+++ b/drivers/gpu/drm/bridge/Makefile
@@ -6,6 +6,7 @@ obj-$(CONFIG_DRM_CHRONTEL_CH7033) += chrontel-ch7033.o
 obj-$(CONFIG_DRM_CROS_EC_ANX7688) += cros-ec-anx7688.o
 obj-$(CONFIG_DRM_DISPLAY_CONNECTOR) += display-connector.o
 obj-$(CONFIG_DRM_FSL_LDB) += fsl-ldb.o
+obj-$(CONFIG_DRM_IMX9_PARALLEL_DISPLAY_FORMAT) += imx9-parallel-disp-fmt.o
 obj-$(CONFIG_DRM_ITE_IT6263) += ite-it6263.o
 obj-$(CONFIG_DRM_ITE_IT6505) += ite-it6505.o
 obj-$(CONFIG_DRM_LONTIUM_LT8912B) += lontium-lt8912b.o
diff --git a/drivers/gpu/drm/bridge/imx9-parallel-disp-fmt.c b/drivers/gpu/drm/bridge/imx9-parallel-disp-fmt.c
new file mode 100644
index 0000000000000..c37bdda53377c
--- /dev/null
+++ b/drivers/gpu/drm/bridge/imx9-parallel-disp-fmt.c
@@ -0,0 +1,213 @@
+// SPDX-License-Identifier: GPL-2.0-or-later
+/*
+ * Copyright (C) 2022 NXP
+ * Copyright (c) 2026 TQ-Systems GmbH <linux@ew.tq-group.com>,
+ * D-82229 Seefeld, Germany.
+ * Author: Alexander Stein
+ */
+
+#include <linux/media-bus-format.h>
+#include <linux/mfd/syscon.h>
+#include <linux/module.h>
+#include <linux/of.h>
+#include <linux/platform_device.h>
+#include <linux/regmap.h>
+#include <drm/drm_atomic_helper.h>
+#include <drm/drm_bridge.h>
+#include <drm/drm_of.h>
+#include <drm/drm_panel.h>
+
+#define DISPLAY_MUX_CTRL		0x60
+#define  PARALLEL_DISP_FORMAT		GENMASK(10, 8)
+#define  FORMAT_RGB888_TO_RGB888	FIELD_PREP(PARALLEL_DISP_FORMAT, 0)
+#define  FORMAT_RGB888_TO_RGB666	FIELD_PREP(PARALLEL_DISP_FORMAT, 1)
+#define  FORMAT_RGB565_TO_RGB565	FIELD_PREP(PARALLEL_DISP_FORMAT, 2)
+#define  FORMAT_RGB555_TO_RGB555	FIELD_PREP(PARALLEL_DISP_FORMAT, 3)
+#define  FORMAT_YUV_TO_YCBCR24		FIELD_PREP(PARALLEL_DISP_FORMAT, 4)
+#define  FORMAT_YUV_TO_YUV444		FIELD_PREP(PARALLEL_DISP_FORMAT, 5)
+
+struct imx9_pdf {
+	struct device *dev;
+	struct drm_bridge bridge;
+	struct drm_bridge *panel_bridge;
+	struct regmap *regmap;
+};
+
+static inline struct imx9_pdf *to_imx9_pdf(struct drm_bridge *bridge)
+{
+	return container_of(bridge, struct imx9_pdf, bridge);
+}
+
+static int imx9_pdf_attach(struct drm_bridge *bridge,
+	enum drm_bridge_attach_flags flags)
+{
+	struct imx9_pdf *pdf = to_imx9_pdf(bridge);
+
+	return drm_bridge_attach(bridge->encoder, pdf->panel_bridge,
+	       			 bridge, flags);
+}
+
+static void imx9_pdf_atomic_enable(struct drm_bridge *bridge,
+				   struct drm_bridge_state *old_bridge_state)
+{
+	struct imx9_pdf *pdf = to_imx9_pdf(bridge);
+	struct drm_atomic_state *state = old_bridge_state->base.state;
+	const struct drm_bridge_state *bridge_state;
+	u32 format;
+
+	/* Get the bus format from the bridge state. */
+	bridge_state = drm_atomic_get_new_bridge_state(state, bridge);
+
+	switch (bridge_state->output_bus_cfg.format) {
+	case MEDIA_BUS_FMT_RGB565_1X16:
+		format = FORMAT_RGB565_TO_RGB565;
+		break;
+	case MEDIA_BUS_FMT_RGB666_1X18:
+		format = FORMAT_RGB888_TO_RGB666;
+		break;
+	case MEDIA_BUS_FMT_RGB888_1X24:
+		format = FORMAT_RGB888_TO_RGB888;
+		break;
+	default:
+		/*
+		 * Some bridges still don't set the correct bus format.
+		 * Just print a warning.
+		 */
+		dev_warn(pdf->dev,
+			 "Unsupported bus format 0x%04x, please check output bridge driver\n",
+			 bridge_state->output_bus_cfg.format);
+		return;
+	}
+
+	regmap_update_bits(pdf->regmap, DISPLAY_MUX_CTRL, PARALLEL_DISP_FORMAT,
+			   format);
+}
+
+#define MAX_INPUT_SEL_FORMATS 2
+static u32 *
+imx9_pdf_atomic_get_input_bus_fmts(struct drm_bridge *bridge,
+				   struct drm_bridge_state *bridge_state,
+				   struct drm_crtc_state *crtc_state,
+				   struct drm_connector_state *conn_state,
+				   u32 output_fmt,
+				   unsigned int *num_input_fmts)
+{
+	u32 *input_fmts;
+
+	*num_input_fmts = 0;
+
+	input_fmts = kcalloc(MAX_INPUT_SEL_FORMATS, sizeof(*input_fmts),
+			     GFP_KERNEL);
+	if (!input_fmts)
+		return NULL;
+
+	input_fmts[0] = MEDIA_BUS_FMT_RGB888_1X24;
+	input_fmts[1] = MEDIA_BUS_FMT_RGB565_1X16;
+	*num_input_fmts = MAX_INPUT_SEL_FORMATS;
+
+	return input_fmts;
+}
+
+#define MAX_OUTPUT_SEL_FORMATS 3
+static u32 *
+imx9_pdf_atomic_get_output_bus_fmts(struct drm_bridge *bridge,
+				    struct drm_bridge_state *bridge_state,
+				    struct drm_crtc_state *crtc_state,
+				    struct drm_connector_state *conn_state,
+				    unsigned int *num_output_fmts)
+{
+	u32 *output_fmts;
+
+	*num_output_fmts = 0;
+
+	output_fmts = kcalloc(MAX_OUTPUT_SEL_FORMATS, sizeof(*output_fmts),
+			     GFP_KERNEL);
+	if (!output_fmts)
+		return NULL;
+
+	output_fmts[0] = MEDIA_BUS_FMT_RGB565_1X16;
+	output_fmts[1] = MEDIA_BUS_FMT_RGB666_1X18;
+	output_fmts[2] = MEDIA_BUS_FMT_RGB888_1X24;
+	*num_output_fmts = MAX_OUTPUT_SEL_FORMATS;
+
+	return output_fmts;
+}
+
+static enum drm_mode_status
+imx9_pdf_mode_valid(struct drm_bridge *bridge,
+		   const struct drm_display_info *info,
+		   const struct drm_display_mode *mode)
+{
+	if (mode->clock > 80000)
+		return MODE_CLOCK_HIGH;
+
+	return MODE_OK;
+}
+
+static const struct drm_bridge_funcs funcs = {
+	.attach = imx9_pdf_attach,
+	.atomic_enable = imx9_pdf_atomic_enable,
+	.atomic_duplicate_state = drm_atomic_helper_bridge_duplicate_state,
+	.atomic_destroy_state = drm_atomic_helper_bridge_destroy_state,
+	.atomic_get_input_bus_fmts = imx9_pdf_atomic_get_input_bus_fmts,
+	.atomic_get_output_bus_fmts = imx9_pdf_atomic_get_output_bus_fmts,
+	.atomic_reset = drm_atomic_helper_bridge_reset,
+	.mode_valid = imx9_pdf_mode_valid,
+};
+
+static int imx9_pdf_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct device_node *remote;
+	struct drm_panel *panel;
+	struct imx9_pdf *pdf;
+
+	pdf = devm_kzalloc(dev, sizeof(*pdf), GFP_KERNEL);
+	if (!pdf)
+		return -ENOMEM;
+
+	pdf->dev = &pdev->dev;
+	pdf->bridge.funcs = &funcs;
+	pdf->bridge.of_node = dev->of_node;
+	pdf->bridge.type = DRM_MODE_CONNECTOR_DPI;
+
+	pdf->regmap = syscon_node_to_regmap(dev->of_node->parent);
+	if (IS_ERR(pdf->regmap))
+		return dev_err_probe(dev, PTR_ERR(pdf->regmap),
+				     "failed to get regmap\n");
+
+	remote = of_graph_get_remote_node(dev->of_node, 1, 0);
+	panel = of_drm_find_panel(remote);
+	of_node_put(remote);
+	if (IS_ERR(panel))
+		return PTR_ERR(panel);
+
+	pdf->panel_bridge = devm_drm_panel_bridge_add(dev, panel);
+	if (IS_ERR(pdf->panel_bridge))
+		return PTR_ERR(pdf->panel_bridge);
+
+	platform_set_drvdata(pdev, pdf);
+
+	devm_drm_bridge_add(dev, &pdf->bridge);
+
+	return 0;
+}
+
+static const struct of_device_id imx9_pdf_dt_ids[] = {
+	{ .compatible = "fsl,imx9-parallel-display-format", },
+	{ /* sentinel */ }
+};
+MODULE_DEVICE_TABLE(of, imx9_pdf_dt_ids);
+
+static struct platform_driver imx9_pdf_driver = {
+	.probe		= imx9_pdf_probe,
+	.driver		= {
+		.name		= "imx9-parallel-display-format",
+		.of_match_table	= imx9_pdf_dt_ids,
+	},
+};
+module_platform_driver(imx9_pdf_driver);
+
+MODULE_AUTHOR("Alexander Stein <alexander.stein@ew.tq-group.com>");
+MODULE_DESCRIPTION("i.MX91/i.MX93 parallel display format driver");
+MODULE_LICENSE("GPL v2");